/*
 * Copyright (c) 2004 Sendmail, Inc. and its suppliers.
 *      All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: edbcexists.c,v 1.7 2011/02/22 06:28:48 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/memops.h"
#include "sm/heap.h"
#include "sm/str.h"
#include "sm/edbc.h"
#include "edbc.h"
#include "sm/qmgrdbg.h"

/*
**  EDBC_EXISTS -- does an entry with rcpt_id exist in envelope database cache
**
**	Parameters:
**		edbc_ctx -- edbc context
**		rcpt_id -- Recipient Id
**		pedbc_node -- (pointer to) edbc_node (output)
**
**	Returns:
**		true iff found
**
**	Locking: must be performed by caller.
*/

bool
edbc_exists(edbc_ctx_P edbc_ctx, rcpt_id_T rcpt_id, edbc_node_P *pedbc_node)
{
	edbc_node_P edbc_node;

	SM_REQUIRE(edbc_ctx != NULL);
	edbc_node = edbc_ht_find(edbc_ctx, rcpt_id);
	if (pedbc_node != NULL)
		*pedbc_node = edbc_node;
	return edbc_node != NULL;
}
