/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: strl1chr.c,v 1.3 2010/09/24 01:38:17 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/ctype.h"
#include "sm/str.h"
#include "sm/str-int.h"

/*
**  SM_STR_L1CHR -- find last occurrence of a char in str
**
**	Parameters:
**		str -- string in which to find delim
**		delim -- char to find
**		pidx -- index in string at which delim appears first
**			only valid for SM_SUCCESS
**
**	Returns:
**		usual error code
*/

sm_ret_T
sm_str_l1chr(sm_str_P str, uchar delim, uint *pidx)
{
	uchar ch;
	uint len;
	int i;

	SM_IS_BUF(str);
	SM_REQUIRE(pidx != NULL);

	len = sm_str_getlen(str);

	/* search for delimiter */
	for (i = len - 1; i >= 0; i--) {
		ch = sm_str_rd_elem(str, i);
		if (delim == ch) {
			*pidx = i;
			return SM_SUCCESS;
		}
	}
	return sm_error_perm(SM_EM_STR, SM_E_NOTFOUND);
}
