#!/bin/sh
# $Id: t-failtoooften-0.sh,v 1.2 2013/12/24 04:31:28 ca Exp $
#
# Copyright (c) 2013 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.
#
# ----------------------------------------
# test restart functionality of mcp:
# "server" fails too often ("HARD") but outside the timeout.
# ----------------------------------------

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
L1=smar.log
. ${SD}/common.sh

for i in smar
do
  rm -f $i
  ln -s ${PRG} $i
done

cat > ${CONF} <<EOF
smar {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./smar;
	arguments = "smar -p ${PIDF1} -f ${R1} -n 6 -VV -s 2 -W";
}
EOF

echo 0 > ${R1}
./mcp -F 1 -f 5 -D -t -dddd ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}

waitforfile ${PIDF1}

# give it time to restart several times then fail
sleep 12

if grep 'service=smar, .*status=server failed too often' ${OUT} >/dev/null
then
  echo "$0: ERROR: found 'server failed too often' in ${OUT}"
  ERRS=`expr ${ERRS} + 1 `
fi
C=`grep -c 'execl ./smar' ${OUT}`
if [ X"$C" != "X7" ]
then
  echo "$0: ERROR: wrong number of execl smar: ${C}"
  ERRS=`expr ${ERRS} + 1 `
fi

stopit
testend
