#!/bin/sh
# $Id: t-pass-hup-0.sh,v 1.11 2013/12/23 01:26:27 ca Exp $
# Copyright (c) 2004, 2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test HUP functionality of mcp to bind again to a port and pass it
# to a service.
# ----------------------------------------

RPLY=clt.out
CONF=mcp.conf1
SOCK=127.0.0.1
PORT=1357
SOCKET=passfd
PRG=../statethreads/examples/smtps2

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
. ${SD}/common.sh

if test ! -x $PRG
then
  echo $0: missing $PRG
  exit 1
fi

rm -f ${PIDS} ${OUT} ${RPLY}

cat > ${CONF} <<EOF
smtps2 {
	start_action = pass;
	listen_socket { type=inet;port = ${PORT};}
	pass_fd_socket = ${SOCKET};
	processes_min = 1;
	processes_max = 1;
	user = ${USER};
	path = "${PRG}";
	arguments = "smtps2 -O ${SOCKET} -d 2";
}
EOF

./mcp -D -t -d ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}

sleep 3

# connect to inout
../misc/t-unixcl -r -p ${PORT} ${SOCK} >${RPLY} 2>/dev/null <<EOF
QUITz
EOF
ST=$?

# restart
for i in `cat ${PIDS}`
do
  kill -HUP ${i}
done

# connect to inout
../misc/t-unixcl -r -p ${PORT} ${SOCK} >${RPLY} 2>/dev/null <<EOF
QUITz
EOF
ST=$?


stopit

test ${ERRS} -eq 0 && rm -f smtps2.log ${OUT} ${RPLY} ${PIDS} ${CONF} ${SOCK} ${SOCKET}

exit ${ERRS}
